<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { IItemListUpsale } from "~/interfaces/discount";
import { cloneDeep, maxBy } from "lodash";

@Component({})
export default class SettingSellerUpsaleBlockComponent extends Vue {
  @Prop()
  tab!: number;

  // listUpsale: IItemListUpsale[] = [];
  listUpsaleClone: IItemListUpsale[] = [];
  listOption = [
    {
      name: "Fixed Amount",
      value: 2,
    },
    { name: "Percent (%)", value: 1 },
  ];

  text = "";

  mounted() {
    this.onGetListUpsale();
    this.text = this.listUpsale.text;
  }

  async onGetListUpsale() {
    try {
      this.listUpsaleClone = cloneDeep(this.listUpsale);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  onChanged() {
    this.$store.commit("sellerStore/setStoreStore", {
      buyMore: {
        text: this.text,
        listBuyMore: this.listUpsale.listBuyMore,
      },
    });
  }

  addUpsale() {
    if (this.listUpsale && !this.listUpsale.listBuyMore) {
      this.listUpsale.listBuyMore = [];
    }
    const findLargestNumber: any = maxBy(
      this.listUpsale.listBuyMore,
      "quantity"
    ) || {
      quantity: 0,
    };
    this.listUpsale.listBuyMore.push({
      quantity: findLargestNumber.quantity + 1,
      content: 2,
      discount: 0,
    });

    this.onChanged();
  }

  deleteUpSale(i: number) {
    this.listUpsale.listBuyMore.splice(i, 1);
    this.onChanged();
  }

  get listUpsale() {
    return (
      cloneDeep(this.$store.state?.sellerStore?.store?.store?.buyMore) || {
        text: "",
        listBuyMore: [],
      }
    );
  }
}
</script>

<style lang="scss">
#hideBottomInput.table-upsale td {
  padding: 12px 0px !important;
}

#hideBottomInput.table-upsale {
  th,
  tr,
  td {
    border: none;
  }
}
</style>
